/****************************************/
/* Cool Herders                         */
/* A demented muse by Brendan Wiese     */
/* http://starbow.org                   */
/* Programmed by Mike Brent             */
/* http://tursi.yiffco.com              */
/* font.c                               */
/****************************************/

// Font routines. Binky gave me two fonts - a
// big one and a small one

#include <stdio.h>
#include <malloc.h>
#include <kallisti/libk.h>
#include <kallisti/timer.h>
#include <kallisti/abi/fs.h>
#include <kallisti/abi/ta.h>
#include <kallisti/abi/spu.h>
#include <kallisti/abi/maple.h>
#include <kallisti/abi/video.h>
#include <kallisti/abi/thread.h>
#include <kallisti/abi/maple.h>
#include <kallisti/abi/sndsrv_abi.h>
#include <kallisti/irq.h>
#include <kallisti/vmu.h>
#include <kallisti/biosfont.h>
#include "../kosh/abi/conio.h"

#include "sprite.h"
#include "cool.h"
#include "font.h"

extern uint32 txr_smfont, txr_lgfont;

char fontstr[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890!?&\".@*%:;";
const int LGX=20;
const int LGY=40;
const int SMX=16;
const int SMY=32;

int CursorX, CursorY;

void DrawFont(int large, int x, int y, int alpha, char *str) {
	uint32 txr;
	int x1, y1;
	int w, h, n;
	int c;
	char *ptr;

	if (-1==x) x=CursorX;
	if (-1==y) y=CursorY;

	while (*str) {
		if (large) {
			txr=txr_lgfont;
			w=LGX;
			h=LGY;
			n=12;
		} else {
			txr=txr_smfont;
			w=SMX;
			h=SMY;
			n=16;
		}
		
		ptr=fontstr;
		c=0;
		while (*ptr) {
			if (*ptr == *str) {
				break;
			}
			ptr++;
			c++;
		}

		if (*ptr) {
			x1=(c%n)*w;
			y1=(c/n)*h;

			addPage2(txr, x, y, x1, y1, x1+w-1, y1+h-1, alpha);
		}

		str++;
		x+=w;
	}

	CursorX=x;
	CursorY=y+h-10;
}

void CenterDrawFont(int large, int y, int alpha, char *str) {
	int x;

	if (-1==y) y=CursorY;
	if (large) {
		x=strlen(str)*LGX;
	} else {
		x=strlen(str)*SMX;
	}
	x=(640-x)/2;

	DrawFont(large, x, y, alpha, str);
}
